Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.

Bug 1426960

Summary: Review Request: nodejs-body-parser - Node.js body parsing middleware
Product: [Fedora] Fedora Reporter: Ben Rosser <rosser.bjr>
Component: Package ReviewAssignee: Tom Hughes <tom>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: package-review, tom
Target Milestone: ---Flags: tom: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2017-04-06 13:43:13 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On:    
Bug Blocks: 956806, 1426962    

Description Ben Rosser 2017-02-26 21:14:20 UTC
Spec URL: https://tc01.fedorapeople.org/quassel/quassel-webserver/nodejs-body-parser.spec
SRPM URL: https://tc01.fedorapeople.org/quassel/quassel-webserver/nodejs-body-parser-1.16.1-1.fc25.src.rpm

Description: Parse incoming request bodies in a middleware before your handlers,
availabe under the req.body property.

This does not handle multipart bodies, due to their complex and
typically large nature.

Fedora Account System Username: tc01

Note that (as is noted in the spec) this patch [1] is required because we ship an outdated nodejs-supertest, and a single unit test does not work with the version we ship. I simply disabled the test; all other tests pass.

[1] https://tc01.fedorapeople.org/quassel/quassel-webserver/nodejs-body-parser-disable-json-test.patch

Comment 1 Tom Hughes 2017-03-18 11:03:46 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 19 files have
     unknown license. Detailed output of licensecheck in /home/tom/1426960
     -nodejs-body-parser/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-body-parser-1.16.1-1.fc27.noarch.rpm
          nodejs-body-parser-1.16.1-1.fc27.src.rpm
nodejs-body-parser.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-body-parser.noarch: W: spelling-error Summary(en_US) middleware -> middle ware, middle-ware, middleweight
nodejs-body-parser.noarch: W: spelling-error %description -l en_US middleware -> middle ware, middle-ware, middleweight
nodejs-body-parser.noarch: W: spelling-error %description -l en_US availabe -> available, availability
nodejs-body-parser.noarch: W: spelling-error %description -l en_US req -> re, freq, res
nodejs-body-parser.noarch: W: spelling-error %description -l en_US multipart -> multiparty, multiplier
nodejs-body-parser.noarch: W: only-non-binary-in-usr-lib
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/depd /usr/lib/node_modules/depd
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/type-is /usr/lib/node_modules/type-is
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/qs /usr/lib/node_modules/qs
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/iconv-lite /usr/lib/node_modules/iconv-lite
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/on-finished /usr/lib/node_modules/on-finished
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/raw-body /usr/lib/node_modules/raw-body
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/bytes /usr/lib/node_modules/bytes
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/content-type /usr/lib/node_modules/content-type
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/http-errors /usr/lib/node_modules/http-errors
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/debug /usr/lib/node_modules/debug
nodejs-body-parser.src: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-body-parser.src: W: spelling-error Summary(en_US) middleware -> middle ware, middle-ware, middleweight
nodejs-body-parser.src: W: spelling-error %description -l en_US middleware -> middle ware, middle-ware, middleweight
nodejs-body-parser.src: W: spelling-error %description -l en_US availabe -> available, availability
nodejs-body-parser.src: W: spelling-error %description -l en_US req -> re, freq, res
nodejs-body-parser.src: W: spelling-error %description -l en_US multipart -> multiparty, multiplier
nodejs-body-parser.src:12: W: macro-in-comment %{npmname}
nodejs-body-parser.src:12: W: macro-in-comment %{npmname}
nodejs-body-parser.src:12: W: macro-in-comment %{version}
2 packages and 0 specfiles checked; 0 errors, 26 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-body-parser.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-body-parser.noarch: W: spelling-error Summary(en_US) middleware -> middle ware, middle-ware, middleweight
nodejs-body-parser.noarch: W: spelling-error %description -l en_US middleware -> middle ware, middle-ware, middleweight
nodejs-body-parser.noarch: W: spelling-error %description -l en_US availabe -> available, availability
nodejs-body-parser.noarch: W: spelling-error %description -l en_US req -> re, freq, res
nodejs-body-parser.noarch: W: spelling-error %description -l en_US multipart -> multiparty, multiplier
nodejs-body-parser.noarch: W: only-non-binary-in-usr-lib
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/bytes /usr/lib/node_modules/bytes
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/content-type /usr/lib/node_modules/content-type
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/debug /usr/lib/node_modules/debug
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/depd /usr/lib/node_modules/depd
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/http-errors /usr/lib/node_modules/http-errors
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/iconv-lite /usr/lib/node_modules/iconv-lite
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/on-finished /usr/lib/node_modules/on-finished
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/qs /usr/lib/node_modules/qs
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/raw-body /usr/lib/node_modules/raw-body
nodejs-body-parser.noarch: W: dangling-symlink /usr/lib/node_modules/body-parser/node_modules/type-is /usr/lib/node_modules/type-is
1 packages and 0 specfiles checked; 0 errors, 17 warnings.



Requires
--------
nodejs-body-parser (rpmlib, GLIBC filtered):
    nodejs(engine)
    npm(bytes)
    npm(content-type)
    npm(debug)
    npm(depd)
    npm(http-errors)
    npm(iconv-lite)
    npm(on-finished)
    npm(qs)
    npm(raw-body)
    npm(type-is)



Provides
--------
nodejs-body-parser:
    nodejs-body-parser
    npm(body-parser)



Source checksums
----------------
https://github.com/expressjs/body-parser/archive/1.16.1/body-parser-1.16.1.tar.gz :
  CHECKSUM(SHA256) this package     : 15120487aaaf65fb8235f2ebbaeeb8c210afd3a183cace4819021e1a2da97049
  CHECKSUM(SHA256) upstream package : 15120487aaaf65fb8235f2ebbaeeb8c210afd3a183cace4819021e1a2da97049


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1426960
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Tom Hughes 2017-03-18 11:04:29 UTC
Needs updating to new (1.17.1) upstream release and there's a typo in the description:

nodejs-body-parser.noarch: W: spelling-error %description -l en_US availabe -> available, availability

Comment 3 Ben Rosser 2017-03-22 14:39:53 UTC
Spec URL: https://tc01.fedorapeople.org/quassel/quassel-webserver/nodejs-body-parser.spec

SRPM URL: https://tc01.fedorapeople.org/quassel/quassel-webserver/nodejs-body-parser-1.17.1-1.fc25.src.rpm

- Update to latest upstream release.
- Fix a typo in the package description.

Comment 4 Tom Hughes 2017-03-22 20:53:22 UTC
Thanks. That looks fine now.

Comment 5 Gwyn Ciesla 2017-03-23 12:34:30 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/nodejs-body-parser

Comment 6 Fedora Update System 2017-03-24 14:18:57 UTC
nodejs-body-parser-1.17.1-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-f224621d63

Comment 7 Fedora Update System 2017-03-24 22:53:50 UTC
nodejs-body-parser-1.17.1-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-f224621d63

Comment 8 Fedora Update System 2017-04-06 13:43:13 UTC
nodejs-body-parser-1.17.1-1.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.